import mongo.build_db as pool_database
import mongo.query_db as pool_database_query

from flask import Flask, render_template, request, jsonify, redirect

app = Flask(__name__)

@app.route("/", methods=["GET","POST"])
def index():
    if request.method == "POST":
        username = request.form["username"]
        password = request.form["password"]
        db = pool_database_query.pool_query()
        if db.user_check(username, password):
            return redirect("/updater")
        else:
            return render_template("index.html", try_again=True)
    else:
        return render_template("index.html", try_again=False)

@app.route("/updater", methods=["GET", "POST"])
def updater():
    query_db = pool_database_query.pool_query()
    query = query_db.get_top(10, "ph")

    if request.method == "POST":
        database = pool_database.pool_data()
        new_record = {
                "ph": f'{request.form["ph"]}',
                "total_chlorine" : f'{request.form["total_chlorine"]}',
                "free_chlorine": f'{request.form["free_chlorine"]}',
                "alkalinity": f'{request.form["alkalinity"]}',
                "salt": f'{request.form["salt"]}',
                "date": f'{request.form["date"]}',
                "test_user": f'{request.form["test_user"]}',
            }
        if database.record_exists(new_record["date"], new_record["test_user"]):
            for field in database.existing_record:
                for new_field in new_record:
                    if field == new_field:
                        if database.existing_record[field] != new_record[field]:
                            database.update_re_record(database.existing_record["_id"], field, new_record[field])
        else:
            database.create_re_record(new_record["ph"], new_record["total_chlorine"], new_record["free_chlorine"], 
                                      new_record["alkalinity"], new_record["date"], new_record["test_user"], new_record["salt"])


        return render_template("updater.html", list=query)
    else:
        return render_template("updater.html", list=query)

@app.route("/update_db", methods=["POST"])
def pool_data_update():
    database = pool_database.pool_data()
    new_record = request.json
    if database.record_exists(new_record["date"], new_record["test_user"]):
        for field in database.existing_record:
            for new_field in new_record:
                if field == new_field:
                    if database.existing_record[field] != new_record[field]:
                        database.update_re_record(database.existing_record["_id"], field, new_record[field])
            else:
                database.create_re_record(new_record["ph"], new_record["total_chlorine"], new_record["free_chlorine"], 
                                      new_record["alkalinity"], new_record["date"], new_record["test_user"], new_record["salt"])


@app.route("/pool_top/<int:return_number>/<string:field>")
def user_detail(id):
    query_db = pool_database_query.pool_query()
    query = query_db.get_top(return_number, field)
    return jsonify([row.to_json() for row in query])

if __name__ == '__main__':
    app.run(host='0.0.0.0', port=80)
